<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<title>Crud de Teste</title>

<script src="https://cdn.jsdelivr.net/npm/vue"></script>
<script src="https://unpkg.com/axios/dist/axios.min.js"></script>

<!-- Bootstrap CSS -->
<link rel="stylesheet" href="../src/css/bootstrap.css">

<!-- Alessandro -->
<link rel="stylesheet" href="../src/css/style.css">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

</head>
<body>
	<header>
		<nav class="navbar navbar-expand-lg navbar-light shadow-sm">
			<button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1">
				<span class="navbar-toggler-icon"></span>
			</button> 
			<a class="navbar-brand" href="#">
				<img width="140px" src="https://www.hepta.com.br/o/tema-modelo-theme/images/horizontal-hepta.png" alt=""/>	
			</a>
			<div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
				<ul class="navbar-nav ml-md-auto">
					<li class="nav-item active">
						<ul class="navbar-nav ml-md-auto">
							<li class="nav-item active">
								<div class="search">
									<input type="text" placeholder=" ">
									<div>
										<svg>
											<use xlink:href="#path">
										</svg>
									</div>
								</div>
								<svg xmlns="http://www.w3.org/2000/svg" style="display: none;">
									<symbol xmlns="http://www.w3.org/2000/svg" viewBox="0 0 160 28" id="path">
										<path d="M32.9418651,-20.6880772 C37.9418651,-20.6880772 40.9418651,-16.6880772 40.9418651,-12.6880772 C40.9418651,-8.68807717 37.9418651,-4.68807717 32.9418651,-4.68807717 C27.9418651,-4.68807717 24.9418651,-8.68807717 24.9418651,-12.6880772 C24.9418651,-16.6880772 27.9418651,-20.6880772 32.9418651,-20.6880772 L32.9418651,-29.870624 C32.9418651,-30.3676803 33.3448089,-30.770624 33.8418651,-30.770624 C34.08056,-30.770624 34.3094785,-30.6758029 34.4782612,-30.5070201 L141.371843,76.386562" transform="translate(83.156854, 22.171573) rotate(-225.000000) translate(-83.156854, -22.171573)"></path>
									</symbol>
								</svg>
							</li>
						</ul>
					</li>
				</ul>
			</div>
		</nav>		
	</header>
	<div class="container-fluid">
		<div id="app_crud" class="div_principal">
			<div class="row">
				<div class="col-md-12 mt-5">
					<h2>{{ dto.nome }}</h2>
					<div class="form-row">
						<div class="col-md-4 mb-3">
							<input type="text" class="form-control" id="" placeholder="Id" v-model="dto.id">
						</div>
						<div class="col-md-4 mb-3">
							<input type="text" class="form-control" id="" placeholder="Nome" v-model="dto.nome">
						</div>
					</div>
					<div style="margin-top:10px" class="form-group">
						<!-- Button -->
						<div class="controls">
							<a id="btn-salvar" href="#" class="btn btn-success" @click="salvarPessoa">Salvar</a>
							<a id="btn-limpar" href="#" class="btn btn-danger" onclick="limparCampos();">Limpar</a>
							<a id="btn-limpar" href="#" class="btn btn-primary" @click="buscarPessoas">Buscar</a>
						</div>
					</div>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="d-flex justify-content-end pb-3 pt-3">
						<span class="badge badge-secondary">{{ totalRegistros }} Registros econtrados</span>
					</div>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<table class="table table-hover">
						<thead>
							<tr>
								<th>
									ID
								</th>
								<th>
									Nome
								</th>
								<th class="text-center">
									Editar
								</th>
								<th class="text-center">
									Excluir
								</th>
							</tr>
						</thead>
						<tbody>
							<tr v-for="obj in lista">
								<td>
									{{ obj.id }}
								</td>
								<td>
									{{ obj.nome }}
								</td>
								<td class="text-center">
									<i @click="editarItem(obj)" style="color: #51a14e; cursor: pointer" class="fa fa-pencil-square-o fa-lg" aria-hidden="true"></i>
								</td>
								<td class="text-center">
									<i @click="excluirItem(obj.id)" style="color: #c30707; cursor: pointer" class="fa fa-times fa-lg" aria-hidden="true"></i>
								</td>
							</tr>
						</tbody>
					</table>
					<nav>
						<ul class="pagination mt-2 mb-5">
							<li class="page-item" v-if="initValue > 5" @click="voltarListagem">
								<a class="page-link" href="#">Anterior</a>
							</li>
							<li class="page-item" v-if="(initValue+10)<totalRegistros" @click="avancarListagem">
								<a class="page-link" href="#">Próximo</a>
							</li>
						</ul>
					</nav>
				</div>
			</div> 
		</div>
	</div>

	<script>
			var vm1 = new Vue({
				el : '#app_crud',
				data : {
					lista : [ {
						id : '1',
						nome : 'Teste'
					} ],
					
					dto : {id : '',
						nome : ''},
					initValue : 0,
					totalRegistros : 0
				},
				methods: {
					buscarPessoas: function() {
					listarPessoasREST();
					},
					
					salvarPessoa : function() {
						axios.post('http://externos.hepta.com.br:8080/CrudWS/rest/pessoa/salvar', this.dto)
							.then(function (response) {
							console.log(response);
							listarPessoasREST();
							limparCampos();
							})
							.catch(function (error) {
							console.log(error);
							});

					},
					editarItem : function(obj) {
						this.dto = obj

					},
					excluirItem : function(id) {
						axios.delete('http://externos.hepta.com.br:8080/CrudWS/rest/pessoa/deletar/'+id)
							.then(function (response) {
							console.log(response);
							listarPessoasREST();
							limparCampos();
							})
							.catch(function (error) {
							console.log(error);
							}); 
						

					},
					voltarListagem : function(){
						this.initValue = this.initValue - 10;
						listarPessoasREST();
					},
					avancarListagem : function(){
						this.initValue = this.initValue + 10;
						listarPessoasREST();
					}
				},
				created: listarInicial()
			})
			
			function limparCampos(){
				vm1.dto = {id:'',nome:''};
			}
			
			function listarPessoasREST(){
				axios.get("http://externos.hepta.com.br:8080/CrudWS/rest/pessoa/listar?initValue="+vm1.initValue)
				.then(response => {console.log(response.data);vm1.lista = response.data
					}).catch(function (error) {
						console.log(error);
					});
				
				getTotalRegistros();
			}
			
			function listarInicial(){
				axios.defaults.headers.common['Content-Type'] = 'application/x-www-form-urlencoded';
				axios.get("http://externos.hepta.com.br:8080/CrudWS/rest/pessoa/listar")
				.then(response => {console.log(response.data);vm1.lista = response.data
					}).catch(function (error) {
						console.log(error);
					});
				
				getTotalRegistros();
			}
			
			
				function getTotalRegistros(){
				axios.get("http://externos.hepta.com.br:8080/CrudWS/rest/pessoa/total")
				.then(response => {vm1.totalRegistros = response.data
					}).catch(function (error) {
						console.log(error);
					});
			}
			
	</script>
	<script src="../src/js/jquery.js"></script>
	<script src="../src/js/popper.js"></script>
	<script src="../src/js/bootstrap.js"></script>
</body>

</html>